// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('taxiApp', ['ionic','ngCordova','ngStorage','taxiApp.services','taxiApp.controllers','taxiApp.map','myApp.directives','taxiApp.profile','taxiApp.previous','taxiApp.share'])

  .run(function($ionicPlatform, $ionicPopup,$window,$ionicHistory) {
        $ionicPlatform.ready(function() {
            if(window.Connection) {
                if(navigator.connection.type == Connection.NONE) {
                    $ionicPopup.confirm({
                        title: "Internet Disconnected",
                        content: "Check your Internet connection and try again later."
                    })

                    .then(function(result) {
                        if(!result) {
                            ionic.Platform.exitApp();
                        }
                    });
                }
                else
                {
                     if($window.localStorage.getItem("hello"))
                   {
                       $window.location="#/app/booking";
                       $ionicHistory.nextViewOptions({
                                disableAnimate: true,
                                disableBack: true
                            });
                      }
                      else
                      {
                        $window.location="#/slide";
                      }
                }
            }
        });
    })
.config(function($stateProvider, $urlRouterProvider,$ionicConfigProvider) {
  $ionicConfigProvider.platform.android.views.maxCache(5);
  $stateProvider
.state('slide', {
   url: '/slide',
   templateUrl: 'templates/slide.html',
   
  })

 .state('home', {
   url: '/home',
   templateUrl: 'templates/login.html',
   controller: 'loginCtrl',
  })

 .state('register', {
    url: "/register",
    templateUrl: "templates/register.html",
    controller:"registerCtrl",   
  })

  .state('ForgetPassword', {
    url: "/fpass",
    templateUrl: "templates/forgetpassword.html",
    controller: "passCtrl"   
  })

.state('updateProfile', {
    url: "/updateProfile",
    templateUrl: "templates/updateProfile.html",
    controller: "updateCtrl"   
  })

  .state('app', {
    url: "/app",
    abstract: true,
    templateUrl: "templates/menu.html",
 })

 .state('app.profile', {
    url: "/profile",
    views: {
      'menuContent': {
        templateUrl: "templates/profile.html",
        controller:  'profileCtrl'
      }
    }
  })

.state('app.booking', {
    url: "/booking",
     controller: 'MapController',
    views: {
      'menuContent': {
        templateUrl: "templates/booking.html"

      }
    }
  })
  .state('app.rate_km', {
    url: "/rate_chart_km",
    views: {
      'menuContent': {
        templateUrl: "templates/rate_chart_km.html"
      }
    }
  })

  .state('app.rate_hr', {
    url: "/rate_chart_hr",
    views: {
      'menuContent': {
        templateUrl: "templates/rate_chart_hr.html"
      }
    }
  })

  .state('app.previous', {
    url: "/previous",
    views: {
      'menuContent': {
        templateUrl: "templates/previous.html"
    }
  }})

    .state('app.about', {
    url: "/about",
    views: {
      'menuContent': {
        templateUrl: "templates/about.html"
    }
  }})
.state('app.sharApp', {
    url: "/shareApp",
    views: {
      'menuContent': {
        controller:  'shareAppCtrl'
      }
    }
  })

 .state('app.contact', {
    url: "/contact",
    controller: 'contactCtrl',
    views: {
      'menuContent': {
        templateUrl: "templates/contact.html"
    }
  }})
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/slide');
});