angular.module('taxiApp.map',['ngCordova'])

	.controller('MapController',['$scope','$window','$http','$ionicLoading','$ionicPopup','$cordovaSocialSharing',function($scope,$window,$http,$ionicLoading,$ionicPopup,$cordovaSocialSharing) {

		var directionsDisplay;
		var directionsService = new google.maps.DirectionsService();
		var map;
	    ionic.Platform.ready(function() {
	      directionsDisplay = new google.maps.DirectionsRenderer();
	        var mapOptions = {
	             
	             zoom: 16,
	            mapTypeId: google.maps.MapTypeId.ROADMAP
	        };
	        var markersArray=[];
	        var markergeo=[];
	 
	        map = new google.maps.Map(document.getElementById("map"), mapOptions);
	         var acOptions = {
	            types: ['establishment']
	        };
	        var geocoder = new google.maps.Geocoder();
	        
	        var infoWindow = new google.maps.InfoWindow();
			   
	navigator.geolocation.getCurrentPosition(function(pos) {
	        map.setCenter(new google.maps.LatLng(pos.coords.latitude, pos.coords.longitude));
	        marker = new google.maps.Marker({
	                position: new google.maps.LatLng(pos.coords.latitude, pos.coords.longitude),
	                icon:'http://maps.google.com/mapfiles/ms/icons/green-dot.png',
	                draggable:true,
	                map: map,
	                title: "My Location"
	            });
	           console.log("my location");
	           console.log(marker.getPosition().lat());
	           console.log(marker.getPosition().lng());
	           
	           infoWindow.setContent('<div><strong>'+ "You are here!!" + '</strong><br>');
	     infoWindow.open(map, marker);
	         },
	         function onError(error){
	                $ionicPopup.confirm({
                        title: "Enable GPS ? ",
                        content: "Your device GPS is disabled, Please Enable it."

                    })
                    .then(function(result) {
                        if(result) {
                        	cordova.plugins.diagnostic.switchToLocationSettings();
                        	ionic.Platform.exitApp();
                        }
                        else
                        	ionic.Platform.exitApp();
                    });
	         },{maximumAge:60000,timeout:3000,enableHighAccuracy:true});

			

		function setMarkers(map, locations) {

		  var image = {
		    url:'taxi1.png',
		  
		  };
		  
	  for (var i = 0; i < locations.length; i++) {
		    var beach = locations[i];
		    var myLatLng = new google.maps.LatLng(beach[0], beach[1]);
		    var marker = new google.maps.Marker({
		        position: myLatLng,
		        map: map,
		        icon: image,
		    });
		  }
		}	        

var driverlocation=[]; 

$scope.driver=function(){

          var obj = [{
                        'user_location_lat' : marker.getPosition().lat(),
                        'user_location_long': marker.getPosition().lng()
          }]
      var request = $http({
          method: "post",
          url: "http://nanotaxi.dmsinfosystem.com/index.php/home/cab_location_app",
          data: obj,
          headers : {'Content-Type':undefined,} 
    });
           $ionicLoading.show({
            template: '<ion-spinner icon="android"></ion-spinner>'
          });
       
          request.success(function(data, status, headers, config) {
          	$ionicLoading.hide();
          	var driverlocation= data.cab_location;
          	setMarkers(map, driverlocation);
            console.log(data.cab_location);
             
         });

          request.error(function(data, status, headers, config) {
              $ionicLoading.hide();
            console.log("error",data);
          });

};


	    navigator.geolocation.watchPosition(function(pos) {
	            watchid=new google.maps.LatLng(pos.coords.latitude, pos.coords.longitude);
	             if ( markergeo.length>0)
									{
									  markera.setMap(null);
									  markergeo=[];
									}

	            markera =new google.maps.Marker({
							                position: watchid,
	                 						icon:
	       {
	     path: google.maps.SymbolPath.FORWARD_CLOSED_ARROW,
	      scale: 3 },

	                map: map,
	                zoom:20,
	                draggable:true,
	                title: "My Location"
	                });
	            markergeo.push(markera);
	             $scope.GeoMe=function()
	             {
	              map.setCenter(new google.maps.LatLng(pos.coords.latitude, pos.coords.longitude));
	              map.setZoom(18);
            };

	});

	google.maps.event.addListener(map, 'click', function (e) {

	  var location = e.latLng;

	  if ( markersArray.length>0)
	{
	  markerb.setMap(null);
	  markersArray=[];
	}
	        
	   markerb= new google.maps.Marker({
	            position: location,
	            draggable:true,
	            map: map
	        });
	   
	markersArray.push(markerb);
	console.log("destination");
	console.log(markerb.getPosition().lat());
	console.log("src"+marker.getPosition().lng());

	  directionsDisplay.setMap(map);
	  
	     var infoWindow1 = new google.maps.InfoWindow(); 
	     var request = {
	        
	        origin : marker.getPosition(),
	        destination : markerb.getPosition(),
	        travelMode : google.maps.TravelMode.DRIVING,
	         provideRouteAlternatives: true
	  };
	  
	  directionsService.route(request, function(response, status) {
	    if (status == google.maps.DirectionsStatus.OK) {

	      directionsDisplay.setDirections(response);
	      directionsDisplay.setOptions( { suppressMarkers: true } );
	      var distance = response.routes[0].legs[0].distance.text;
	            var time= response.routes[0].legs[0].duration.text;
	            var dist=response.routes[0].legs[0].distance.value;
	            var fare= "Rs"+" "+((dist/1000)*40).toFixed(2);
	            console.log(fare);
	            infoWindow.setContent('<div><strong>'+ "Distance: " + distance+'</strong><br>'+'<div><strong>'+ "Driving Time: " + time+'</strong><br>'+'<div><strong>'/*"Appox Fare: " +fare+'</strong><br>'*/);
	     	infoWindow.open(map,markerb);

	    }


	  });
	  
	});

	var autocomplete = new google.maps.places.Autocomplete(document.getElementById('autocomplete'),acOptions);
	         autocomplete.bindTo('bounds',map);
	          google.maps.event.addListener(autocomplete, 'place_changed', function() {
	var place = autocomplete.getPlace();
	       if (place.geometry.viewport) {
	       map.fitBounds(place.geometry.viewport);
	      } else {
	        map.setCenter(place.geometry.location);
	       map.setZoom(16);
	       }

	
	    if ( markersArray.length>0)
				{
				  markerb.setMap(null);
				  markersArray=[];
				}


	       markerb= new google.maps.Marker({
	            position: place.geometry.location,
	            map: map
	        });

	       markersArray.push(markerb);
	       console.log(markerb.getPosition());
	  		directionsDisplay.setMap(map);
	  
	     var infoWindow1 = new google.maps.InfoWindow(); 
	     var request = {
	        
	        origin : marker.getPosition(),
	        destination : markerb.getPosition(),
	        travelMode : google.maps.TravelMode.DRIVING,
	         provideRouteAlternatives: true
	  };
	  
	  directionsService.route(request, function(response, status) {
	    if (status == google.maps.DirectionsStatus.OK) {

	      directionsDisplay.setDirections(response);
	      directionsDisplay.setOptions( { suppressMarkers: true } );
	      var distance = response.routes[0].legs[0].distance.text;
	            var time= response.routes[0].legs[0].duration.text;
	    
	            var dist=response.routes[0].legs[0].distance.value;
	             var fare= "Rs"+" "+((dist/1000)*40).toFixed(2);
	             console.log(fare);
	              infoWindow.setContent('<div><strong>'+ "Distance: " + distance+'</strong><br>'+'<div><strong>'+ "Driving Time: " + time+'</strong><br>'+'<div><strong>'/*+"Appox Fare: " +fare+'</strong><br>'*/);
	           infoWindow.open(map,markerb);              

	    }
	  });
	   
	  });
	        
	        $scope.map = map;
	       
	    });

      $scope.confirm = function() {
    
      console.log($window.localStorage.getItem("hello"));
      console.log("loc"+markerb.getPosition());
		console.log(markera.getPosition());


       var obj= [{
                            'token'             :$window.localStorage.getItem("hello"),
                            'pickup_from_lat'   :marker.getPosition().lat(),
                            'pickup_from_long'  :marker.getPosition().lng(),
                            'pickup_to_lat'		:markerb.getPosition().lat(),
                            'pickup_to_long'	:markerb.getPosition().lng(),
                            'pickup_date'		:new Date(),
                            'tariff_type' 		:"test tariff"

                            }]; 

       var request = $http({
          method: "post",
          url: "http://nanotaxi.dmsinfosystem.com/index.php/home/booking_app",
          data: obj,
          //headers : {'Content-Type':undefined,} 
    });
       $ionicLoading.show({
            template: '<ion-spinner icon="android"></ion-spinner>'
          });


       
          request.success(function(data, status, headers, config) {
            console.log(data);
            $ionicLoading.hide();
            if (data.status==1) {
                $ionicPopup.alert({
						     title: 'Alert',
						     template: data.status_message,
							})
                /*.then(function(result) {
                        if(result) {
*/					            markerb.setMap(null);
					   			directionsDisplay.setMap(null);

	/*				   			var msg = {
									phoneNumber:'9826600940',
									textMessage:"test"
								};
						sms.send(msg, function(message) {
									$ionicPopup.alert("success: ");

								}, function(error) {
									$ionicPopup.alert("error: " + error.code);
									
								});


                        }
                    });*/
   		 }
            else if (data.status==0){
               $ionicPopup.alert({
						     title: 'Alert',
						     template: data.status_message,
						   });
            }

            else {
                 $ionicLoading.hide();
                 $ionicPopup.alert({
						     title: 'Alert',
						     template: 'Something went wrong, Try again after sometime.'
						   });

         		}
   		 });

       request.error(function(data, status, headers, config) {
          	$ionicLoading.hide();
            console.log("error",data)
          });


      };
	 

/*	 $cordovaSocialSharing
    .shareViaSMS("Hey! I'm travelling from"+, '9826600940')
    .then(function(result) {
      // Success!
      $ionicPopup.alert("Message sent");
    }, function(err) {
      // An error occurred. Show a message to the user
      $ionicPopup.alert("Message not sent");
    });
*/
}]);
